#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lfinput.h"

static void scan(char *input, size_t len) {
    size_t sz = strlen(input);

    for (size_t i = 0; i < sz - len; ++i) {
        int char_set[256];
        memset(char_set, 0, sizeof(int) * 256);
        char *start = &input[i];
        char *end = &input[i + len];
        int fail = 0;

        do {
            if(char_set[*start] > 0) {
                fail = 1;
                break;
            }
            char_set[*start] = 1;
            ++start;
        } while (start != end);

        if (!fail) {
            printf("%zu\n", i + len);
            break;
        }
    }
}

void advent2022day06(void) {
    char *input = get_input("input/2022/06");
    scan(input, 4);
    scan(input, 14);
    free(input);
}
